std::erase_if(std::unordered_set)(3)

NAME
std::erase_if(std::unordered_set) - std::erase_if(std::unordered_set)

Synopsis
   Defined in header <unordered_set>
   template< class Key, class Hash, class KeyEqual, class Alloc, class
   Pred >
                        (since
   typename std::unordered_set<Key,Hash,KeyEqual,Alloc>::size_type C++20)
   erase_if( std::unordered_set<Key,Hash,KeyEqual,Alloc>& c, Pred pred );
   Erases all elements that satisfy the predicate pred from the container. Equivalent
   to
 auto old_size = c.size();
 for (auto i = c.begin(), last = c.end(); i != last; ) {
   if (pred(*i)) {
     i = c.erase(i);
   } else {
     ++i;
   }
 }
 return old_size - c.size();

Parameters
   c - container from which to erase
   pred - predicate that returns true if the element should be erased

Return value
   The number of erased elements.

Complexity
   Linear.

Example
// Run this code
 #include <unordered_set>
 #include <iostream>
 template<typename Os, typename Container>
 inline Os& operator<<(Os& os, Container const& container)
 {
     os << "{ ";
     for (const auto& item : container) {
         os << item << ' ';
     }
     return os << "}";
 }
 int main()
 {
     std::unordered_set data { 3, 3, 4, 5, 5, 6, 6, 7, 2, 1, 0 };
     std::cout << "Original:\n" << data << '\n';
     auto divisible_by_3 = [](auto const& x) { return (x % 3) == 0; };
     const auto count = std::erase_if(data, divisible_by_3);
     std::cout << "Erase all items divisible by 3:\n" << data << '\n'
               << count << " items erased.\n";
 }

Possible output:
 Original:
 { 0 1 2 7 6 5 4 3 }
 Erase all items divisible by 3:
 { 1 2 7 5 4 }
 3 items erased.

See also
   remove removes elements satisfying specific criteria
   remove_if (function template)